searchNodes=[{"ref":"Mix.Tasks.Check.html","title":"Mix.Tasks.Check","type":"task","doc":"One task to efficiently run all code analysis &amp; testing tools in an Elixir project. Tools Following curated tools are configured by default: :compiler - produces compilation warnings that allow to early detect bugs &amp; typos in the code eg. an attempt to call non-existing or deprecated function :formatter - ensures that all the code follows the same basic formatting rules such as maximum number of chars in a line or function indentation :ex_unit - starts the application in test mode and runs all runtime tests against it (defined as test modules or embedded in docs as doctests) :credo - ensures that all the code follows a further established set of software design, consistency, readability &amp; misc rules and conventions (still statical) :sobelow - performs security-focused static analysis mainly focused on the Phoenix framework, but also detecting vulnerable dependencies in arbitrary Mix projects :dialyzer - performs static code analysis around type mismatches and other issues that are commonly detected by static language compilers :ex_doc - compiles the project documentation in order to ensure that there are no issues that would make it impossible for docs to get collected and assembled You can disable or adjust curated tools as well as add custom ones via the configuration file. Workflow :compiler tool is run before others in order to compile the project just once and to avoid reprinting the compilation error multiple times. If the compilation succeded (even if with warnings), further tools are run in parallel while their output is streamed live one by one for instant insight. Output from tools that have failed gets reprinted for sake of easily reading into them all at once and identifying all project issues in one go. Summary is presented with a list of all tools that have failed, succeeded or were skipped due to missing files or project dependencies. Task halts the VM with exit code that equals to the number of failed tools. This means non-zero exit code if at least one tool has failed. Tool execution Tools are run in separate processes. This has following benefits: allows to run tools in parallel &amp; stream their output catches exit codes in order to detect failures enables including non-Elixir scripts and tools in the check The downside is that tools will be run without TTY which will usually result in tools disabling ANSI formatting. This issue is fixed for mix tasks (which often depend on IO.ANSI.format/1 for output formatting) by wrapping them in mix do that explicitly enables ANSI. Configuration file Check configuration may be adjusted with the optional .check.exs file. Task will load the configuration in following order: Default stock configuration. .check.exs in user home directory. .check.exs in umbrella root directory when called from sub-project. .check.exs in current project directory. Configuration file should evaluate to keyword list with following options: :exit_status - toggles halting EVM to return non-zero exit status (default: true) :parallel - toggles running tools in parallel (default: true) :skipped - toggles printing skipped tools in summary (default: true) :tools - a list of tools to run (default: curated tools) Each tool is a{:tool_name, opts} tuple where opts is a keyword list with following options: :command - command as string or list of strings (executable + arguments) :cd - directory (relative to cwd) to change to before running the command :env - environment variables as map with string keys &amp; values :enable_ansi - toggles wrapping mix tasks to have ANSI enabled (default: true) :enabled - toggles including already defined tools in the check (default: true) :order - integer that controls the order in which tool output is presented (default: 0) :require_deps - list of package atoms that must be present or tool will be skipped :require_files - list of file name strings that must be present or tool will be skipped Use the mix check.gen.config task to generate sample configuration that comes with well-commented examples to help you get started. Command line options --only dialyzer --only credo ... - run only specified check(s) --except dialyzer --except credo ... - don&#39;t run specified check(s) --no-exit-status - don&#39;t halt EVM to return non-zero exit status --no-parallel - don&#39;t run tools in parallel --no-skipped - don&#39;t print skipped tools in summary"},{"ref":"Mix.Tasks.Check.Gen.Config.html","title":"Mix.Tasks.Check.Gen.Config","type":"task","doc":"Generates optional configuration file (.check.exs) for adjusting the check."},{"ref":"readme.html","title":"ex_check","type":"extras","doc":"ex_check One task to efficiently run all code analysis &amp; testing tools in an Elixir project. Runs all tools with a single convenient mix check command Comes out of the box with a predefined set of curated tools Checks the project consistently for all developers &amp; on the CI Facilitates custom mix tasks and scripts acting as project checks Delivers results faster by running &amp; streaming tools in parallel Identifies all project issues in one go by always running all tools Takes care of the little details (compile once, enable ANSI etc) Read more and see demo on Cloudless Studio blog."},{"ref":"readme.html#getting-started","title":"ex_check - Getting started","type":"extras","doc":"Add ex_check to your list of dependencies in mix.exs: def deps do [ {:ex_check, &quot;&gt;= 0.0.0&quot;, only: :dev, runtime: false} ] end Optionally add curated tools to your list of dependencies in mix.exs: def deps do [ {:credo, &quot;&gt;= 0.0.0&quot;, only: :dev, runtime: false}, {:dialyxir, &quot;&gt;= 0.0.0&quot;, only: :dev, runtime: false}, {:ex_doc, &quot;&gt;= 0.0.0&quot;, only: :dev, runtime: false}, {:sobelow, &quot;&gt;= 0.0.0&quot;, only: :dev, runtime: false} ] end Run the check: mix check Optionally generate config to adjust the check: mix check.gen.config"},{"ref":"readme.html#continuous-integration","title":"ex_check - Continuous Integration","type":"extras","doc":"With mix check you can consistently run the same set of checks locally and on the CI. CI configuration also becomes trivial and comes out of the box with parallelism and error output from all checks at once regardless if previous one failed. Here&#39;s the minimal .travis.yml to get you started on Travis CI: language: elixir script: mix check If you use the dialyzer tool, you&#39;ll also want to cover PLT build timeouts and caching: # ... before_script: - travis_wait mix dialyzer --plt cache: directories: - _build - deps"},{"ref":"readme.html#documentation","title":"ex_check - Documentation","type":"extras","doc":"Learn more about the task workflow, included tools, configuration and options: mix help check Read docs for mix check on HexDocs: latest version."}]